#include <stdio.h>                                                                                                                                               
#include <stdlib.h>
#include <CL/cl.h>
 
int main() {
 
    int i, j;
    char* value;
 
    cl_uint platformCount;
    cl_platform_id* platforms;

    cl_uint deviceCount;
    cl_device_id* devices;

	size_t valueSize;
	size_t work_item_size[3];
	size_t work_group_size;
	cl_uint work_item_dimensions;
    cl_uint maxComputeUnits;
	cl_bool image_support;
	cl_device_type device_type;
	cl_ulong global_mem_size;
	cl_ulong local_mem_size;

    //  ÷ ҷ´.
    clGetPlatformIDs(0, NULL, &platformCount);
    platforms = (cl_platform_id*) malloc(sizeof(cl_platform_id) * platformCount);
    clGetPlatformIDs(platformCount, platforms, NULL);

    for (i = 0; i < platformCount; i++) {
		
        //  ̽ ġ ҷ´.
        clGetDeviceIDs(platforms[i], CL_DEVICE_TYPE_ALL, 0, NULL, &deviceCount);
        devices = (cl_device_id*) malloc(sizeof(cl_device_id) * deviceCount);
        clGetDeviceIDs(platforms[i], CL_DEVICE_TYPE_ALL, deviceCount, devices, NULL);
 
        //  ̽ ġ  Ӽ
        for (j = 0; j < deviceCount; j++) {
 
			printf("-----------------------------------------------------\n");
            clGetDeviceInfo(devices[j], CL_DEVICE_NAME, 0, NULL, &valueSize);
            value = (char*) malloc(valueSize);
            clGetDeviceInfo(devices[j], CL_DEVICE_NAME, valueSize, value, NULL);
            printf("%d.1. CL_DEVICE_NAME: %s \n", j+1, value);
			free(value);

			clGetDeviceInfo(devices[j], CL_DEVICE_TYPE, sizeof(cl_device_type), &device_type, NULL);
			if( device_type & CL_DEVICE_TYPE_CPU )
			printf("%d.2. CL_DEVICE_TYPE: CPU \n",j+1);
			if( device_type & CL_DEVICE_TYPE_GPU )
			printf("%d.2. CL_DEVICE_TYPE: GPU \n",j+1);

			clGetDeviceInfo(devices[j], CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS, sizeof(cl_uint), &work_item_dimensions, NULL);
			printf("%d.3. CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS: %d\n",j+1, work_item_dimensions);
			
			clGetDeviceInfo(devices[j], CL_DEVICE_MAX_WORK_ITEM_SIZES, 3*sizeof(size_t), work_item_size, NULL);
			printf("%d.4. CL_DEVICE_MAX_WORK_ITEM_SIZES: (%lu,%lu,%lu)\n",j+1, work_item_size[0], work_item_size[1], work_item_size[2]);
			
		    clGetDeviceInfo(devices[j], CL_DEVICE_MAX_WORK_GROUP_SIZE, sizeof(size_t), &work_group_size, NULL);
			printf("%d.5. CL_DEVICE_MAX_WORK_GROUP_SIZE: %lu\n",j+1, work_group_size);
			
            clGetDeviceInfo(devices[j], CL_DEVICE_MAX_COMPUTE_UNITS, sizeof(cl_uint), &maxComputeUnits, NULL);
            printf("%d.6. CL_DEVICE_MAX_COMPUTE_UNITS: %d \n",j+1, maxComputeUnits); 

			clGetDeviceInfo(devices[j], CL_DEVICE_GLOBAL_MEM_SIZE, sizeof(cl_ulong), &global_mem_size, NULL);
            printf("%d.7. CL_DEVICE_GLOBAL_MEM_SIZE: %ul \n",j+1, global_mem_size); 

			clGetDeviceInfo(devices[j], CL_DEVICE_LOCAL_MEM_SIZE, sizeof(cl_ulong), &local_mem_size, NULL);
            printf("%d.8. CL_DEVICE_LOCAL_MEM_SIZE: %ul \n",j+1, local_mem_size); 

			printf("-----------------------------------------------------\n"); 
        }
        free(devices);
    }
    free(platforms);
    return 0;
}